function [non_attr, non_cent, non_cent2] = noneligible_attributes_centroids (dataset, labels_provided, cents, stddevs, counts)


[n_inst, n_attr] = size(dataset);
if(labels_provided)
	n_attr = n_attr - 1;
end

stddevThr = 0;
nearZero = 1e-3;
countThr1 = 1;
countThr2 = 0.01 * n_inst;
countThr3 = 0.99 * n_inst;

non_cent = zeros(n_attr, size(stddevs,2)-1);
non_attr = zeros(n_attr,1);
zeroStdDev = 0;
smallCount = 0;

for(i = 1:n_attr)
	if((counts(i,1)==1) || (counts(i,1)==2 && cents(i,2)==cents(i,3)) || ...
	   (sum(counts(i,2:end)>=countThr3)))
% 	if((cents(i,2)==cents(i,3) && stddevs(i,2)==0 && mean(dataset(:,i))==dataset(1,i)))
		non_attr(i,1) = 1;
		continue;
	end
	
	for(j = 2:cents(i,1)+1)
		
		if((counts(i,j)==0) || ...
		   ((cents(i,j)==0) && (stddevs(i,j)<=stddevThr) && (counts(i,j)>=countThr2)) || ...
		   ((cents(i,j)<=nearZero) && (stddevs(i,j)<=nearZero) && (counts(i,j)>=countThr2))) % change line 47 accordingly
				non_cent(i,j-1) = 1;
				zeroStdDev = zeroStdDev + 1;
		end
		
	end
end

non_cent2 = non_cent;
% find the attributes with discrete values, therefore std=0,
% and remove them from list of noneligible (i.e. add to eligibles)
% In fact this part of code removes attributes for which all clusters 
% have std=0, i.e. the attribute is composed of some discrete values
for(i = 1:n_attr)
	if(non_attr(i,1)==0 && sum(stddevs(i,2:1+stddevs(i,1))==0) == stddevs(i,1))
		if(find(counts(i,:)==n_inst)) 
			% Determines if all instances belong to just one cluster
			% if so remove them all from noneligible
			% If all instances belong to the same cluster, it hasn't
			% accomplished anything, then the attribute is useless.
			non_attr(i,1) = 1;
% 			non_cent(i,1:stddevs(i,1)) = zeros(1,stddevs(i,1));
		else
			% only remove those clusters which have a small count
			% and keep the cluster with most instances noneligible
			non_cent(i,1:stddevs(i,1)) = zeros(1,stddevs(i,1));
% 			idx = find(counts(i,:)==max(counts(i,:)));
% 			non_cent(i,idx-1) = 1; % "-1" because counts vector has a leading value which determines # of clusters
		end
	end
end

sum(non_cent2(:))
sum(non_cent(:))

end % function
